## gate.gui
Class SchemaAnnotationEditor

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.JComponent
                        |
                        +--javax.swing.JPanel
                              |
                              +--gate.creole.AbstractVisualResource
                                    |
                                    +--gate.gui.SchemaAnnotationEditor

All Implemented Interfaces:
  Accessible, AnnotationVisualResource, FeatureBearer, ImageObserver, MenuContainer, NameBearer, Resource, Serializable, VisualResource

public class SchemaAnnotationEditor
extends AbstractVisualResource
implements AnnotationVisualResource

This class is a viewer which adds/edits features on a GATE annotation. This viewer is `AnnotationSchema` driven.

See Also:
  Serialized Form

Inner classes inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Fields inherited from class javax.swing.JComponent
`TOOL_TIP_TEXT_KEY, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`SchemaAnnotationEditor()` Default constructor

Method Summary
`void` `cancelAction()` Called by the GUI when the user has pressed the "Cancel" button.
`boolean` `canDisplayAnnotationType(String annotationType)` Checks whether this viewer/editor can handle a specific annotation type.
`void` `okAction()` Called by the GUI when the user has pressed the "OK" button.
`void` `setAnnotation(Annotation ann)` Used when the viewer/editor has to display/edit an existing annotation
`void` `setSpan(Long startOffset, Long endOffset, String annotType)` Used when the viewer has to create new annotations.
`void` `setTarget(Object target)` Called by the GUI when this viewer/editor has to initialise itself for a specific annotation or text span.

Methods inherited from class gate.creole.AbstractVisualResource
`cleanup, getFeatures, getParameterValue, init, setFeatures, setHandle, setParameterValue, setParameterValues`

Methods inherited from class javax.swing.JPanel
`getAccessibleContext, getUIClassID, updateUI`

Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addPropertyChangeListener, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAutoscrolls, getBorder, getBounds, getClientProperty, getConditionForKeyStroke, getDebugGraphicsOptions, getGraphics, getHeight, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getVerifyInputWhenFocusTarget, getVisibleRect, getWidth, getX, getY, grabFocus, hasFocus, hide, isDoubleBuffered, isFocusCycleRoot, isFocusTraversable, isLightweightComponent, isManagingFocus, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isPreferredSizeSet, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, print, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDoubleBuffered, setEnabled, setFont, setForeground, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getLayout, insets, invalidate, isAncestorOf, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, remove, remove, removeAll, removeContainerListener, setLayout, validate`

Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, bounds, checkImage, checkImage, contains, createImage, createImage, dispatchEvent, enable, enableInputMethods, getBackground, getBounds, getColorModel, getComponentOrientation, getCursor, getDropTarget, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getInputContext, getInputMethodRequests, getLocale, getLocation, getLocationOnScreen, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, imageUpdate, inside, isDisplayable, isEnabled, isLightweight, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface gate.VisualResource
`setHandle`

Methods inherited from interface gate.Resource
`cleanup, getParameterValue, init, setParameterValue, setParameterValues`

Methods inherited from interface gate.util.FeatureBearer
`getFeatures, setFeatures`

Methods inherited from interface gate.util.NameBearer
`getName, setName`

Constructor Detail

### SchemaAnnotationEditor

    public SchemaAnnotationEditor()

  Default constructor

Method Detail

### setTarget

    public void setTarget(Object target)

  Called by the GUI when this viewer/editor has to initialise itself for a specific annotation or text span.
  Specified by:
    `setTarget` in interface `AnnotationVisualResource`
  Overrides:
    `setTarget` in class `AbstractVisualResource`
  Parameters:
    `target` - the object which will always be a `AnnotationSet`

### setAnnotation

    public void setAnnotation(Annotation ann)

  Used when the viewer/editor has to display/edit an existing annotation
  Specified by:
    `setAnnotation` in interface `AnnotationVisualResource`
  Parameters:
    `ann` - the annotation to be displayed or edited. If ann is null then the method simply returns

### setSpan

    public void setSpan(Long startOffset,
                        Long endOffset,
                        String annotType)

  Used when the viewer has to create new annotations.
  Specified by:
    `setSpan` in interface `AnnotationVisualResource`
  Parameters:
    `startOffset` - the start offset of the span covered by the new annotation(s). If is null the method will simply return.
    `endOffset` - the end offset of the span covered by the new annotation(s). If is null the method will simply return.

### okAction

    public void okAction()
                  throws GateException

  Called by the GUI when the user has pressed the "OK" button. This should trigger the saving of the newly created annotation(s)
  Specified by:
    `okAction` in interface `AnnotationVisualResource`

### cancelAction

    public void cancelAction()
                      throws GateException

  Description copied from interface: `AnnotationVisualResource`
  Called by the GUI when the user has pressed the "Cancel" button. This should trigger cleaning up action, if the editor has done any changes to the annotation sets or document or annotation
  Specified by:
    `cancelAction` in interface `AnnotationVisualResource`

### canDisplayAnnotationType

    public boolean canDisplayAnnotationType(String annotationType)

  Checks whether this viewer/editor can handle a specific annotation type.
  Specified by:
    `canDisplayAnnotationType` in interface `AnnotationVisualResource`
  Parameters:
    `annotationType` - represents the annotation type being questioned.If it is null then the method will return false.
  Returns:
    true if the SchemaAnnotationEditor can handle the annotationType or false otherwise.